// MDITest.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MDITest.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MDITestDoc.h"
#include "MDITestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CMyMultiDocTemplate : public CMultiDocTemplate {
    public:
       CMyMultiDocTemplate(UINT nIDResource, CRuntimeClass * pDocClass, CRuntimeClass * pFrameClass, CRuntimeClass * pViewClass) :
	     CMultiDocTemplate(nIDResource, pDocClass, pFrameClass, pViewClass) { }
       virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
    protected:
       afx_msg void OnTemplate();
       DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CMyMultiDocTemplate, CMultiDocTemplate)
        ON_COMMAND(IDM_TEMPLATE, OnTemplate)
END_MESSAGE_MAP()


/****************************************************************************
*                       CMyMultiDocTemplate::OnTemplate
* Result: void
*       
* Effect: 
*       Notes that we have reached the template
****************************************************************************/

void CMyMultiDocTemplate::OnTemplate()
    {
     AfxGetMainWnd()->PostMessage(UWM_LOG, FALSE, (LPARAM)new CString(_T("CMyMultiDocTemplate::OnTemplate")));
     AfxMessageBox(_T("CMyMultiDocTemplate"));
    } // CMyMultiDocTemplate::OnTemplate


/////////////////////////////////////////////////////////////////////////////
// CMDITestApp

BEGIN_MESSAGE_MAP(CMDITestApp, CWinApp)
	//{{AFX_MSG_MAP(CMDITestApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(IDM_APP, OnApp)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMDITestApp construction

CMDITestApp::CMDITestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMDITestApp object

CMDITestApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMDITestApp initialization

BOOL CMDITestApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMyMultiDocTemplate(
		IDR_MDITESTYPE,
		RUNTIME_CLASS(CMDITestDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMDITestView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMDITestApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMDITestApp message handlers


void CMDITestApp::OnApp() 
{
 AfxGetMainWnd()->PostMessage(UWM_LOG, FALSE, (LPARAM)new CString(_T("CMDITestApp::OnApp")));
 AfxMessageBox(_T("CMDITestApp"));
}

/****************************************************************************
*                            CMDITestApp::OnCmdMsg
* Inputs:
*       UINT nID:
*	int nCode:
*	void * pExtra:
*	AFX_CMDHANDLERINFO * pHandlerInfo:
* Result: BOOL
*       Superclass result
* Effect: 
*       Logs passing through the template
****************************************************************************/

BOOL CMyMultiDocTemplate::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
   {
    CMDITestApp::LogCmdMsg(nID, nCode, pExtra, pHandlerInfo, _T("CMyMultiDocTemplate::OnCmdMsg"));
    return CMultiDocTemplate::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
   }

/****************************************************************************
*                            CMDITestApp::OnCmdMsg
* Inputs:
*       UINT nID:
*	int nCode:
*	void * pExtra:
*	AFX_CMDHANDLERINFO * pHandlerInfo:
* Result: BOOL
*       Superclass result
* Effect: 
*       Logs the fact that the app has seen the routing of the message
****************************************************************************/

BOOL CMDITestApp::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
 CMDITestApp::LogCmdMsg(nID, nCode, pExtra, pHandlerInfo, _T("CMDITestApp::OnCmdMsg"));
 return CWinApp::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

/****************************************************************************
*                             CMDITestApp::GetStr
* Inputs:
*       UINT nCode: Code value
* Result: CString
*       
* Effect: 
*       Formats the code string
****************************************************************************/

CString CMDITestApp::GetStr(UINT nCode)
    {
     if(nCode == CN_UPDATE_COMMAND_UI)
	return CString(_T("WM_UPDATE_COMMAND_UI"));
     if(HIWORD(nCode) == CN_COMMAND)
	{ /* command */
	 return CString(_T("WM_COMMAND"));
	} /* command */
     CString s;
     s.Format(_T("Code 0x%08x"), nCode);
     return s;
    } // CMDITestApp::GetStr

/****************************************************************************
*                            CMDITestApp::LogItem
* Inputs:
*       UINT nID: Command ID
*	int nCode: Notification code
*	void * pExtra:
*	AFX_CMDHANDLERINFO * pHandlerInfo
* Result: void
*       
* Effect: 
*       Formats the message and posts it to the main window
* Notes:
*	This is a static method so it can be called from LogCmdMsg
****************************************************************************/

void CMDITestApp::LogItem(UINT nID, int nCode, void * pExtra, AFX_CMDHANDLERINFO * pHandlerInfo, LPCSTR event, LPCTSTR where)
    {
     CString * s = new CString;
     s->Format(_T("%-33.33s %-5.5s %-20.20s %s"),
	        // |        |      |        |
	           where,// |      |        |
                //          |      |        |
	                    pHandlerInfo == NULL ? _T("") : _T("query"),
	        //                 |        |
	                           GetStr(nCode),
	        //                          |  
	                                    event);

     AfxGetMainWnd()->PostMessage(UWM_LOG, TRUE, (LPARAM)s);
     
    } // CMDITestApp::LogItem

/****************************************************************************
*                           CMDITestApp::LogCmdMsg
* Inputs:
*       UINT nID: Command ID
*	int nCode: event code
*	void * pExtra:
*	AFX_CMDHANDLERINFO * pHandlerInfo
*	LPCTSTR where: Notification site
* Result: void
*       
* Effect: 
*       Logs the message
* Notes:
*	This is a static method so it can be called from any class
****************************************************************************/

void CMDITestApp::LogCmdMsg(UINT nID, int nCode, void * pExtra, AFX_CMDHANDLERINFO * pHandlerInfo, LPCTSTR where)
    {
     switch(nID)
	{/* nID */
	 case 0xE701:
	 case 0xE702:
	 case 0xE703:
	 case 0xE800:
	 case 0xE100:
	 case 0xE101:
	 case 0xE103:
	 case 0xE107:
	 case 0xE122:
	 case 0xE123:
	 case 0xE125:
	 case 0xE140:
	    break;
	 //----------------------------------------------------------------
	 case IDM_TEMPLATE:
	    LogItem(nID, nCode, pExtra, pHandlerInfo, _T("IDM_TEMPLATE"), where);
	    return;
	 //----------------------------------------------------------------
	 case IDM_VIEW:
	    LogItem(nID, nCode, pExtra, pHandlerInfo, _T("IDM_VIEW"), where);
	    return;
	 //----------------------------------------------------------------
	 case IDM_DOCUMENT:
	    LogItem(nID, nCode, pExtra, pHandlerInfo, _T("IDM_DOCUMENT"), where);
	    return;
	 //----------------------------------------------------------------
	 case IDM_MAINFRAME:
	    LogItem(nID, nCode, pExtra, pHandlerInfo, _T("IDM_MAINFRAME"), where);
	    return;
	 //----------------------------------------------------------------
	 case IDM_CHILDFRAME:
	    LogItem(nID, nCode, pExtra, pHandlerInfo, _T("IDM_CHILDRAME"), where);
	    return;
	 //----------------------------------------------------------------
	 case IDM_APP:
	    LogItem(nID, nCode, pExtra, pHandlerInfo, _T("IDM_APP"), where);
	    return;
	 //----------------------------------------------------------------
	 default:
	    break;
	} /* nID */
     
    } // CMDITestApp::LogCmdMsg
