// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MDITest.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
        ON_MESSAGE(UWM_LOG, OnLog)
	ON_MESSAGE(UWM_CLEAR, OnClear)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_EXITMENULOOP()
	ON_WM_CREATE()
	ON_COMMAND(IDM_MAINFRAME, OnMainframe)
	ON_COMMAND(IDM_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	c_Log.Create(CLog::IDD, this);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


/****************************************************************************
*                           CMainFrame::OnMainframe
* Result: void
*       
* Effect: 
*       Logs the fact that the mainframe has processed a command
****************************************************************************/

void CMainFrame::OnMainframe() 
{
 AfxGetMainWnd()->PostMessage(UWM_LOG, FALSE, (LPARAM)new CString(_T("CMainFrame::OnMainFrame")));
 AfxMessageBox(_T("CMainFrame"));
}

/****************************************************************************
*                            CMainFrame::OnCmdMsg
* Inputs:
*       UINT nID: Command ID
*	int nCode: Notification code
*	void * pExtra:
*	AFX_CMDHANDLERINFO * pHandlerInfo:
* Result: BOOL
*       Result of superclass OnCmdMsg handler
* Effect: 
*       Logs the fact that we are passing through this handler
****************************************************************************/

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
 CMDITestApp::LogCmdMsg(nID, nCode, pExtra, pHandlerInfo, _T("CMainFrame::OnCmdMsg"));
 return CMDIFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

/****************************************************************************
*                             CMainFrame::OnLog
* Inputs:
*       WPARAM: passed to child control
*	LPARAM: passed to child control
* Result: LRESULT
*       result of sending the log message to the log window
****************************************************************************/

LRESULT CMainFrame::OnLog(WPARAM wParam, LPARAM lParam)
   {
    return c_Log.SendMessage(UWM_LOG, wParam, lParam);
   } // CMainFrame::OnLog

/****************************************************************************
*                             CMainFrame::OnClear
* Result: void
*       
* Effect: 
*       Sends a "Clear" request to the log window
****************************************************************************/

void CMainFrame::OnClear() 
   {
    c_Log.SendMessage(UWM_CLEAR, 0, 0);
   }

/****************************************************************************
*                         CMainFrame::OnExitMenuLoop
* Inputs:
*	BOOL bIsTrackPopupMenu
* Result: void
*       
* Effect: 
*       Logs the exit-menu-loop event
****************************************************************************/

void CMainFrame::OnExitMenuLoop(BOOL bIsTrackPopupMenu)
   {
    AfxGetMainWnd()->PostMessage(UWM_LOG, TRUE, (LPARAM)new CString(_T("-----------Exit menu loop-----------")));
    CMDIFrameWnd::OnExitMenuLoop(bIsTrackPopupMenu);
   } // CMainFrame::OnExitMenuLoop
